<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


 /**
  * Class for creating documents in HTML
  * For example invoice, delivery note, order-confirmation etc.
  *
  * @since 2011-07
  */
class Doc_Html extends Doc 
{


/**
 * Print bank and aim in html pages
 */
function print_bank_and_aim()
{
    if ($this->doc == 'invoi') {
        $this->make_bank_and_aim();
        if($this->output_format == 'h') {
            print '<p>' . $this->pay_hint . '</p>';

            if (isset($this->bank_details) and $this->bank_details == true) {
                $this->bank_details = nl2br($this->bank_details);
                print '<p>' . $this->bank_details . '</p>';
            }

            if (isset($this->iban_bic) and $this->iban_bic == true) {
                print '<p>' . $this->iban_bic . '</p>';
            }
            
            if (isset($this->tax_number_id)) {
                print '<p>' . $this->tax_number_id . '</p>';
            }
        }
    }
}


/**
 *
 */
function make_html_sender() 
{
    $this->make_sender();
    
    $sender = '<p><span class="small"> ' .  nl2br($this->sender) . '</span>' 
            . '</p>';
    return $sender;
}

/**
 * 
 */
function print_company_name() 
{
    $this->make_company_name();
    ?>
    <style type="text/css">
    #company_name {
        position: absolute;
        height: auto;
        right: auto;
        bottom: auto;
        left: <?php echo $this->arr_company_xy[0]; ?>mm;
        top: <?php echo $this->arr_company_xy[1]; ?>mm;
    }
    </style>
    
    <div id="company_name">
    <p>
        <b>
        <?php
        if ($this->adm['company_name_on'] == 1) {
            $company_name = nl2br($this->adm['company_name']);
            print  $company_name;
        }
        ?>
        </b>
    </p>
</div>
<?php
}

/**
 * 
 */
function print_logo() 
{
    $this->make_logo();
    ?>
    <style type="text/css">
    #logo {
        position: absolute;
        height: auto;
        right: auto;
        bottom: auto;
        left: <?php echo $this->arr_logo_xy[0]; ?>mm;
        top: <?php echo $this->arr_logo_xy[1]; ?>mm;
    }
    img{
        width: <?php echo $this->adm['logo_width']; ?>mm
    }
    </style>
    
    
    <?php
    
    // Logo
        ?>
        <div id="logo">
            <img src="<?php echo LOGO_HTTP  . $this->adm['logo_url']; ?>"
                 width="<?php print $this->adm['logo_width']; ?>" border="0">
        </div>
        <?php
}


/**
 *
 */
function make_html_address($sender_bool=true) 
{
    $this->make_address();

    // Switch address or delivery address
    if ($this->doc != 'deliv') {
        $address = $this->address;
        $postcode_city = $this->postcode_city;
        
    }elseif($this->doc == 'deliv' and $this->ord['id_tbl_address_deliv'] > 0) {
        $address = $this->address_delivery;
        $postcode_city = $this->postcode_city_delivery;
        
    }else{
        $address = $this->address;
        $postcode_city = $this->postcode_city;
    }
    $address_text = '';
    if ($sender_bool == true) {
        $address_text .= $this->make_html_sender();
    }
    $address_text .= '<p>' . nl2br($address) . '<b>' . nl2br($postcode_city)
                  . '</b>' . '</p>';
    return $address_text;
}


/**
 *
 */
function make_html_delivery_address() 
{
    global $la_invoice_address;
    global $la_delivery_address;
    
    $this->make_address();
    
    if ($this->delivery_address_exist == true) {

        // Switch address or deliv address
        if ($this->doc != 'deliv') {
            $address = $this->address_delivery;
            $postcode_city = $this->postcode_city_delivery;
            $address_kind = $la_delivery_address;

        }else{
            $address = $this->address;
            $postcode_city = $this->postcode_city;
            $address_kind = $la_invoice_address;
        }
        
        $delivery_address = '<p style="font-size: 8pt;">' . $address_kind . '<br>'
                          . nl2br($address) . '<b>' . nl2br($postcode_city) 
                          . '</b></p>';
        return $delivery_address;
    }
}


/**
 *
 */
function print_delivery_date() 
{
    $this->make_delivery_date();
        ?>
        <br>
        <?php
             print nl2br($this->delivery_date);
        ?>
        <?php
}


/**
 * Print Positions of the order as a table
 *
 * @global type $la_amount
 * @global type $la_unit_short
 * @global type $la_description
 * @global type $la_tax_short
 * @global type $la_unit_price
 * @global type $la_total_price 
 */
function print_pos() 
{
    global $la_amount;
    global $la_unit_short;
    global $la_description;
    global $la_tax_short;
    global $la_unit_price;
    global $la_total_price;
    ?>
    <tr>
        <th align="center">Pos</th>
        <th align="center"><?php print $la_amount; ?></th>
        <th align="center"><?php print $la_unit_short; ?></th>
        <th align="left"><?php print $la_description; ?></th>
        <th align="right"> <?php if ($this->doc != 'deliv') { print $la_unit_price; } ?></th>
        <th align="right"> <?php if ($this->doc != 'deliv') { print $la_total_price; } ?></th>
        <?php
        if ($this->ord['tax_on'] == 1) {
            ?>
            <th align="center"><?php print $la_tax_short; ?></th>
            <?php
        }
    ?>
    </tr>
    <?php
    // $value important!
    foreach($this->position_rows as $key => $value) {
        ?>
        <tr>
            <?php
        $cell = new Html_Element();
        $cell->tdh(1, $this->position_rows[$key][0], 'align="center"');
        $cell->tdh(1, $this->position_rows[$key][1], 'align="center"');
        $cell->tdh(1, $this->position_rows[$key][2], 'align="center"');
        $cell->tdh(1, $this->position_rows[$key][3]);
        $cell->tdh(1, $this->position_rows[$key][4], 'align="right"');
        $cell->tdh(1, $this->position_rows[$key][5], 'align="right"');
        $cell->tdh($this->ord['tax_on'] == 1, $this->position_rows[$key][6], 
                'align="center"');
        ?>
        </tr>
        <?php
    }
}


/**
 * Print line shipping
 */
function print_shipping() 
{
        ?>
        <tr>
            <?php
            $zelle = new Html_Element();
            $zelle->tdh(1, $this->pos_shipping_output, 'align="center"');
            $zelle->tdh(1, 1, 'align="center"');
            $zelle->tdh(1, '&nbsp', 'align="center"');
            $zelle->tdh(1, $this->subject_shipping_output );
            $zelle->tdh(1, $this->ord['shipping_cost'], 'align="right"');
            $zelle->tdh(1, $this->ord['shipping_cost'], 'align="right"');
            $zelle->tdh($this->ord['tax_on'] == 1, $this->tax_shipping_a_b_output, 'align="center"');
            ?>
        </tr>
        <?php
}
 

/**
 * 
 */
function print_tax_invoice_included() 
{
    $this->make_tax_invoice_included();
    if($this->ord['tax_on'] == 1  and $this->ord['invoice_gross'] == 1 
            and $this->doc != 'deliv')
    {
            $this->tax_invoice_included_output = nl2br($this->tax_invoice_included_output);
            print '<br/>';
            print '<p>' . $this->tax_invoice_included_output . '</p>';
    }
}


/**
 * 
 */
function make_html_head() 
{
    $head = '<p>' . nl2br($this->head_company) . '</p>'
          . '<p><b>' . $this->doc_name . '</b></p>'
          . '<p>' . nl2br($this->head_document) . '</p>';
    return $head;
}


/**
 *
 * @global <type> $la_legend
 */
function print_abbreviations() 
{
    global $la_legend;
    print '<p class="small">' . $la_legend . '</p>';
}


/**
 * print letter
 *
 */
function print_letter() 
{
    ?>
    <p><b><?php print $this->let['reference']; ?></b></p>
    <p>&nbsp;</p>
    <p>&nbsp;</p>
    <p><?php print nl2br( $this->let['letter_text']); ?></p>
    <?php
}


/**
 * gibt die time_delivery aus
 * @global  $pdf
 */
function print_delivery_time() 
{
    $this->make_delivery_time();
    print '<p>' . $this->delivery_time . '</p>';
}


/**
 * Print small businessman
 */
function print_small_businessman() 
{
    $this->make_small_businessman();
    print '<p>' . $this->small_businessman_output . '</p>';
}


/**
 *
 */
function get_arr_company_data_xy() 
{
    return $this->arr_company_data_xy;
}


/**
 *
 */
function print_text($class='') 
{
    $this->text_bottom = nl2br($this->text_bottom);
    print '<p ' . $class . '>'. $this->text_bottom . '</p>';
}


/**
 * Print row net
 */
function print_total_net() 
{
    $this->make_total_net();
    ?>
    <tr>
        <td>&nbsp; </td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td colspan="2">
           <b><?php print $this->word_total_net; ?></b>
        </td>
        <td align="right">
            <b><?php echo $this->amount_net_format; ?> </b>
        </td>
        <?php
        $zelle = new Html_Element();
        $zelle->tdh($this->ord['tax_on'] == 1, '');
        ?>
    </tr>
    <?php
}


/**
 *
 */
function print_tax() 
{
    // $value important 
    foreach ($this->tax_rows as $key => $value) {
        ?>
        <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td colspan="2"><?php print $this->tax_rows[$key][0]; ?> </td>
            <td align="right"><?php print $this->tax_rows[$key][2]; ?></td>
            <td>&nbsp;</td>
        </tr>
        <?php
    }
}


/**
 *
 */
function print_total_gross() 
{
    $this->make_total_gross();
    ?>
    <tr>
        <td> &nbsp; </td>
        <td> &nbsp; </td>
        <td> &nbsp; </td>
        <td colspan="2"><b><?php print $this->word_total_gross; ?> </b></td>
        <td align="right">
            <b><?php print $this->amount_gross_format; ?></b>
        </td>
        <td> &nbsp; </td>
    </tr>
    <?php
}


/**
 *
 */
function print_pos_part_pay() 
{
    $this->make_pos_part_pay();
        
        ?>
        <tr>
            <?php
            $zelle = new Html_Element();
            $zelle->tdh(1, '1', 'align="center"');
            $zelle->tdh(1, $this->amount_output, 'align="center"');
            $zelle->tdh(1, $this->unit_for_output, 'align="center"');
            $zelle->tdh(1, $this->subject_pos_part_pay_output );
            $zelle->tdh(1, $this->total_format, 'align="right"');
            $zelle->tdh(1, $this->total_format, 'align="right"');
            $zelle->tdh($this->ord['tax_on'] == 1, $this->part_pay_tax_rate_output, 'align="center"');
            ?>
        </tr>
        <?php
}


/**
 *
 */
function print_part_pay() 
{
    $true_false = $this->make_part_pay();
    if ($true_false == true) {
        ?>
        <tr>
            <td> &nbsp;</td>
            <td> &nbsp; </td>
            <td> &nbsp; </td>
            <td colspan="2">
            <?php 
            print $this->subject_total_part_pay_output; 
            ?>
            </td>
            <td align="right">
                <?php print $this->partpay_total_format; ?>
            </td>
            <td> &nbsp; </td>
        </tr>
        <?php
    }
}


/**
 *
 */
function print_sum_total() 
{
   $true_false = $this->make_sum_total();
   if ($true_false == true) {
        ?>
        <tr>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            <td colspan="2"><b><?php print $this->word_sum_total; ?></b></td>
            <td align="right"><b>
                <?php print $this->amount_sum_total_format; ?></b>
            </td>
            <td>&nbsp;</td>
        </tr>
        <?php
   }
}


} // end class
?>