<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/**
 * Class for dump a row into a table
 * 
 * @since 2011
 */
class Query_Prepare
{

private $id_name;
private $link_target;
private $field_as_link;

private $name_of_hide_field;
private $order_dir;
private $order_field;
private $table_or_relation;
private $table_new;
private $action_new;
private $text;


/**
 *
 * @global type $adm
 * @global type $rel_calcu_order_item
 * @global type $rel_client_address
 * @global type $rel_client_product_product
 * @global type $rel_letter_address
 * @global type $rel_complaint_address
 * @global type $rel_order_address_worker
 * @global type $rel_auf_auf_pos_ein
 * @global type $rel_product_category_unit
 * @global type $rel_price_category_unit_address 
 */
function get_table_info() 
{
    global $adm;
    global $rel_calcu_order_item;
    global $rel_client_address;
    global $rel_client_product_product;
    global $rel_letter_address;
    global $rel_expense_address;
    global $rel_complaint_address;
    global $rel_order_address_worker;
    global $rel_auf_auf_pos_ein;
    global $rel_product_category_unit;
    global $rel_price_category_unit_address;
    
    global $la_new_address;
    global $la_new_expense;
    global $la_new_letter;
    global $la_new_product;
    global $la_new_price;
    global $la_number;
    global $la_order_id;
    global $la_new_order;
    global $la_id_tbl_order;
    global $la_letter_id;
    global $la_product_id;
    
    $tbl = $_SESSION['tbl'];
    /**
    *  Define table fields
    */
    // 
    if ($tbl == 'adr') {
        $link_target = 'address_edit.php';
        $text = $la_new_address;

    // Calculation
    }elseif ($tbl == 'cal') {
        $link_target ='modul/calc/calc.php';
        $name_of_hide_field = 'kal.hide';
        $table_or_relation = $rel_calcu_order_item;
        $id_name = $la_id_tbl_order;

    // Client
    }elseif ($tbl == 'cli') {
        $link_target = 'address_edit.php';
        $tbl_new  = 'adr';
        $name_of_hide_field = 'kun.hide';
        $table_or_relation = $rel_client_address;

    // Client article
    }elseif($tbl == 'cli_pro') {
        $name_of_hide_field = 'kuna.hide';
        $table_or_relation = $rel_client_product_product;

    // Expense
    }elseif ($tbl == 'exp') {
        #require_once 'modul/expense/expense.inc.php';
        $order_field = 'aus.id';
        $tbl_new = 'adr';
        $action_new = 'query.php';
        $hide = " AND aus.hide != '1'";
        $table_or_relation = $rel_expense_address;
        $text = $la_new_expense;
        $name_of_hide_field = 'aus.hide';

    // Letter
    }elseif ($tbl == 'let') {
        $id_name = $la_letter_id;
        $field_as_link = $la_letter_id;
        $link_target = 'modul/letter/letter.php';
        $name_of_hide_field = 'bri.hide';
        $tbl_new = 'adr';
        $action_new  = 'query.php';
        $order_field = 'bri.id';
        $table_or_relation = $rel_letter_address;
        $text = $la_new_letter;

    // Complaint
    }elseif ($tbl == 'com') {
        $link_target = 'order_edit.php';
        if ($adm['own_doc_number'] == 1) {
            $field_as_link = $la_number;
            $order_field = $la_number;
        }else{
            $field_as_link = $la_order_id;
            $order_field = $la_order_id;
        }
        $order_field = 'com.id';
        $id_name = $la_order_id;
        $tbl_new = 'adr';
        $action_new  = 'query.php';
        $name_of_hide_field = 'com.hide';
        $table_or_relation = $rel_complaint_address;
        $text = 'Neue Lieferantenreklamation';

    // Order
    }elseif ($tbl == 'ord') {
        $link_target = 'order_edit.php';
        if ($adm['own_doc_number'] == 1) {
            $field_as_link = $la_number;
            $order_field = $la_number;
        }else{
            $field_as_link = $la_order_id;
            $order_field = $la_order_id;
        }
        $order_field = 'auf.id';
        $id_name = $la_order_id;
        $tbl_new = 'adr';
        $action_new  = 'query.php';
        $name_of_hide_field = 'auf.hide';
        $table_or_relation = $rel_order_address_worker;
        $text = $la_new_order;

    // Order item
    }elseif ($tbl == 'ord_ite') {
        $hide = " AND aufp.hide != 1 AND auf.hide != 1";
        $name_of_hide_field = array('auf.hide', 'aufp.hide');
        $table_or_relation =  $rel_auf_auf_pos_ein;
        $field_as_link = $la_id_tbl_order;
        $id_name = $la_id_tbl_order;

    // Product
    }elseif ($tbl == 'pro') {
        $id_name = $la_product_id;
        $field_as_link = $la_product_id;
        $name_of_hide_field = 'art.hide';
        $order_field = 'art.id';
        $table_or_relation = $rel_product_category_unit;
        $text = $la_new_product;

    // Price
    }elseif($tbl == 'pri') {
        $tbl_new = 'adr';
        $action_new = 'query.php';
        $name_of_hide_field = 'pre.hide';
        $order_field = 'description';
        $table_or_relation = $rel_price_category_unit_address;
        $text = $la_new_price;
    }
    
    // if $link_target isn't setted
    if(!isset($link_target)){
        $link_target = 'tbl_edit.php';
    }
    
    if (isset($id_name)) {
        $this->id_name = $id_name;
    }
    if (isset($field_as_link)) {
        $this->field_as_link = $field_as_link;
    }
    if (isset($link_target)) {
        $this->link_target = $link_target;
    }
    if (isset($name_of_hide_field)) {
        $this->name_of_hide_field = $name_of_hide_field;
    }
    if (isset($order_field)) {
        $this->order_field = $order_field;
        #$_SESSION['order'] = $order_field;
    }
    if (isset($table_or_relation)) {
        $this->table_or_relation = $table_or_relation;
    }
    if (isset($text)) {
        $this->text = $text;
    }
    if (isset($tbl_new)) {
        $this->table_new = $tbl_new;
    }
    if (isset($action_new)) {
        $this->action_new = $action_new;
    }
    
    /**
    * Order and order direction
    */
    if(     isset($_REQUEST['new']) 
        or isset ($_REQUEST['todo']) 
        or isset ($_REQUEST['search_button']) )
    {
        #$_SESSION['order'] = $order_field;
        #$_SESSION['order_dir'] = $order_dir;
    }
    
}

/**
 *
 * @return string
 */
function make_where_part()
{
    global $where_part;
    
    // WHERE string for todo
    if (isset($_REQUEST['todo'])) { 
        $where_part = "( payed < 1 or delivered < 1)";
    
    // If display or hide button is pressed, take session[query]
    }elseif (isset ($_REQUEST['hide'])) {
        $where_part = $_SESSION['where_part'];
        
    }
    
    // Prevent empty WHERE part (1 instead of '')
    if (empty($where_part)) {
        $where_part = 1;
    }
    
    $_SESSION['where_part'] = $where_part;
    
    
    if (!isset($where_part)) {
        $where_part = $_SESSION['where_part'];
    }
    
    return $where_part;
}


function make_filter_dropdown()
{
    global $tbl_cat;
    global $tbl_wor;
    global $la_filter_without;
    global $menu;
    global $la_all_orders;
    global $la_all_workers;
    global $la_offers;
    global $la_invoices;
    global $la_orders_hidden;
    global $la_filter_without;
    global $la_clients;
    global $la_delivery_address;
    global $la_deliverer;
    
    $filter = new Filter();
    // Product or price
    if ($_SESSION['tbl'] == 'pro' or $_SESSION['tbl'] == 'pri') {
        $filter->set_table_and_field_name($tbl_cat, 'category');
        $filter->set_first_entry_of_arr_options_for_select($la_filter_without);
        $good_filter = $filter->print_form2('fil', 140);
        $menu->add_more_content($good_filter);
    }
    
    // Filter for orders
    if ($_SESSION['tbl'] == 'ord') {
        // Filter workers
        $filter->set_table_and_field_name($tbl_wor, 'username');
        $filter->set_first_entry_of_arr_options_for_select($la_all_workers);
        $good_filter_ord = $filter->print_form2('fil_bea', 140);
        $menu->add_more_content($good_filter_ord);

        // Filter invoices
        $arr4 = array(
            $la_all_orders => 0, 
            $la_offers => 1,
            $la_invoices => 2,
            $la_orders_hidden => 3,
            );
        $filter->set_array_options_for_select($arr4);
        $filter_invoice = $filter->print_form2('fil_invoice', 140);
        $menu->add_more_content($filter_invoice);
    }
    
    // Addresses
    if ($_SESSION['tbl'] == 'adr') {
        $arr4 = array(
            $la_filter_without => 0, 
            $la_clients => 1,
            $la_delivery_address => 2,
            $la_deliverer => 3,
        );
        $filter->set_array_options_for_select($arr4);
        $good_filter_adr = $filter->print_form2('fil_adr', 140);
        $menu->add_more_content($good_filter_adr);
    }
    #return $where_part;
}


function make_where_filter()
{
    // Category
    if(     ($_SESSION['tbl'] == 'pro' or $_SESSION['tbl'] == 'pri') 
            and isset ($_SESSION['fil']) 
            and $_SESSION['fil'] != 0 ) 
    {
        $filter = " AND id_tbl_category = " . $_SESSION['fil'];
    }
    
    // Address
    if( ($_SESSION['tbl'] == 'adr') and isset ($_SESSION['fil_adr']) and $_SESSION['fil_adr'] != 0 ) {
        if($_SESSION['fil_adr'] == 1) {
            $filter = ' AND id_tbl_client >0';
        }elseif($_SESSION['fil_adr'] == 2) {
            $filter = " AND delivery_address_on = 1";
        }elseif($_SESSION['fil_adr'] == 3) {
            $filter = " AND deliverer = 1";
        }
    }
    
    // Operator filter
    if ($_SESSION['tbl'] == 'ord') {
        if(isset ($_SESSION['fil_bea']) and $_SESSION['fil_bea'] != 0 ) 
        {
            $filter = ' AND auf.id_tbl_worker = '. $_SESSION['fil_bea'];
        }

        if (isset($_SESSION['fil_invoice'])) {
            // All invoices filter
            if($_SESSION['fil_invoice'] == 2 ) {
                $filter = " AND auf.date_invoice > 1 ";
            }

            // All offers
            if($_SESSION['fil_invoice'] == 1 ) {
                $filter = " AND auf.date_invoice < 1 ";
            }

            // Deleted Orders filter
            if($_SESSION['fil_invoice'] == 3 ) {
                $filter = " AND auf.hide = 1 ";
            }
        }
    }
    
    if (!isset($filter)) {
        $filter = '';
    }
    
    return $filter;
}


/**
 *
 * @return type 
 */
function get_order_field()
{
    // Default order field
    if (!isset ($this->order_field)) {
        $this->order_field = 'id';
    }
    
    if(     isset($_REQUEST['new']) 
        or isset ($_REQUEST['todo']) 
        or isset ($_REQUEST['search_button']) )
    {
        $_SESSION['order'] = $this->order_field;
    }
    
    $this->order_field = $_SESSION['order'];
    
    return $this->order_field;
}

/**
 *
 * @return string
 */
function make_order_dir()
{
    /**
    * Order and order direction
    */
    if(     isset($_REQUEST['new']) 
        or isset ($_REQUEST['todo']) 
        or isset ($_REQUEST['search_button']) )
    {
        $_SESSION['order_dir'] = $this->order_dir;
    }
    
    $this->order_dir = $_SESSION['order_dir'];
    
    return $this->order_dir;
}



/**
 *
 * @return type 
 */
function get_order_dir()
{
    // Default order field
    if (!isset ($this->order_dir)) {
        $this->order_dir = 'DESC';
    }
    return $this->order_dir;
}

/**
 *
 * @return string
 */
function get_id_name()
{
    global $la_id;
    // Default id-name
    if (!isset ($this->id_name)) {
        $this->id_name = $la_id;
    }
    return $this->id_name;
}

function get_link_target()
{
    return $this->link_target;
}

function get_field_as_link()
{
    global $la_id;
    // Default field as link
    if (!isset ($this->field_as_link)) {
        $this->field_as_link = $la_id;
    }
    return $this->field_as_link;
}

function get_name_of_hide_field()
{
    if (!isset($this->name_of_hide_field)) {
        $this->name_of_hide_field = 'hide';
    }
    return $this->name_of_hide_field;
}



function get_table_or_realation()
{
    // Default table
    if (!isset ($this->table_or_relation)) {
        $this->table_or_relation = $GLOBALS['tbl_'.$_SESSION['tbl']];
    }
    return $this->table_or_relation;
}

function get_text()
{
    return $this->text;
}

function get_table_new()
{
    return $this->table_new;
}

function get_action_new()
{
    // Default target file for new insert
    if (!isset($this->action_new)) {
        $this->action_new = 'tbl_insert.php';
    }
    return $this->action_new;
}


} // end class