<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/**
* Class for creating tabs
*
* Required: none
* @since   2010-11
*/
class Tab  
{
   // @var <type> array for query string
   private  $arr_param_for_document = array();

   // @var string works on highlightnig of the tab
   private  $document;

   // @var str curren file for highlightening the fitting tab
   private  $current_file;

   // @var arr target file f.i. 'auftrag_av.php'
   private  $arr_target;

   // @var arr inscription of tabs
   private  $arr_inscription;

   /**
    * Set css for the tabs
    */
   function  __construct() 
   {
        ?>
        <style type="text/css">
        /* not selected  */

        </style>
        <?php
    }

   /**
    * Shows tabs. The following content must start with <div
                    style="
                    text-align: left;
                    width: 830px;
                    background-color: #92b28d;
                    border: 2px solid #92b28d;
                    padding: 6px;" >
    *  @return  no
    */
   function make_tabs() 
   {
        $style_1 = 'class="cs1"';
        $style_2 = 'class="cs2"';
        $style_3 = 'class="cs3"';

        $tabs = '';
        
        $tabs .= '<div style="margin: 5px 0px 2px 6px;"> <ul>';
        
        $number_of_tabs = count($this->arr_target);
        for($i=0; $i < $number_of_tabs; $i++) {

            if (isset ($this->arr_param_for_document[$i])) {
                $arr = array('dok' => $this->arr_param_for_document[$i]);
            }else{
                $arr = '';
            }

            $tabs .= '<li ';
            
            if(     $this->current_file == $this->arr_target[$i] 
                and $this->document ==  $this->arr_param_for_document[$i]
              ) 
            {
                $tabs .= $style_2;
            }else{
                $tabs .= $style_1;
            }
            $tabs .= '>';
            
            $link = new Link();
            $link->set_list(false);
            $tabs .=  $link->make_link(PROJECT_HTTP_ROOT.$this->arr_target[$i], 
                    $this->arr_inscription[$i], $arr);

            // Space cell
            $tabs .= "</li>\n";
            if ($i == 0) {
                $tabs .= '<li '.$style_3.' style="width: 20px">  ';
            }else{
                $tabs .= '<li '.$style_3.' style="width: 6px">';
            }
            $tabs .= "</li>\n";
        }
        $tabs .= '</ul> </div>';
    
        return $tabs;
   }


   /**
    *
    * @param type $arr_params_for_document 
    */
   function set_arr_param_for_document($arr_params_for_document) 
   {
       $this->arr_param_for_document = $arr_params_for_document;
   }

   
   /**
    * Set name of file
    * 
    * @param type $file_name 
    */
   function set_current_file($file_name) 
   {
       $this->current_file = $file_name;
   }

   
   /**
    * Set document type
    * 
    * @param type $document 
    */
   function set_document($document) 
   {
       $this->document = $document;
   }

   /**
    * Set destination (filename) for tab
    *
    * @param type $arr_target  
    */
   function set_array_target($arr_target) 
   {
       $this->arr_target = $arr_target;
   }

   /**
    *
    * @param type $arr_inscription 
    */
   function set_array_inscription($arr_inscription) 
   {
       $this->arr_inscription = $arr_inscription;
   }

} // end class
?>