<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Menubar with order details
 * Contains: Order data; tax, delivery details, print; client data; timeline
 */

$link = new Link();
$link->set_class('action');

$bool2 = new Bool_Switch( $use['db_e']);
$bool2->set_table('ord');
$bool2->set_id($_SESSION['auf_id']);
$bool2->set_field_name('tax_on');
$bool2->set_content('ein');

$bool2->set_bool_query($tbl);
$condition = $id_or_nr . " = " . $_SESSION['auf_id'];
$order = $db->get_row_as_array($tbl_ord, $condition);

// Exit if empty order id
if (empty ($order)) {
    print '<div>';
    print link_back_with_query();
    print '<h1 class="error">' . $la_order_id_missing . $_SESSION['auf_id'] . '</h1>';
    print '<div>';
    exit();
}


/**
 * Function for display drop down menues for printing preview
 * 
 * @global type $la_invoice
 * @global type $la_invoice_delivery_note
 * @global type $la_order_conf
 * @global type $la_delivery_note
 * @global type $la_quotation
 * @global type $la_kue
 * @global type $la_partpay_invoice
 * @global type $la_offer
 * @global type $use
 * @param string $h_or_p  "h" for HTML and "p" for PDF
 */
function make_dropdown_print($h_or_p)
{
    global $la_invoice;
    global $la_invoice_delivery_note;
    global $la_order_conf;
    global $la_page_number_without;
    global $la_delivery_note;
    global $la_quotation;
    global $la_kue;
    global $la_partpay_invoice;
    global $la_offer;
    global $use;
    
    // html
    if ($h_or_p == 'h') {
        $action = 'doc.php';
        $active_dd = 1;
        $first = 'HTML';
        $arr3 = array(
            $first . ' ...'                         => '',
            $la_invoice                             => 'invoi',
            $la_invoice_delivery_note               => 'invoi_deliv',
            $la_order_conf                          => 'confi',
            $la_delivery_note                       => 'deliv',
            $la_quotation                           => 'offer',
            $la_kue                                 => 'assum',
            $la_partpay_invoice                     => 'partp',
            $la_offer                               => 'offer',
        );
        
    // pdf
    }else{
        $action = PROJECT_HTTP_ROOT.'modul/pdf/pdf.php';
        if ($use['mod_pdf'] == 1 and is_file(PROJECT_DOCUMENT_ROOT.'/modul/pdf/pdf.php')) {
            $active_dd = 1;
        }else{
            $active_dd = 0;
        }
        $first = 'PDF';
        $arr3 = array(
            $first . ' ...'                         => '',
            $la_invoice                             => 'invoi',
            $la_invoice_delivery_note               => 'invoi_deliv',
            $la_order_conf                          => 'confi',
            $la_delivery_note                       => 'deliv',
            $la_quotation                           => 'offer',
            $la_kue                                 => 'assum',
            $la_partpay_invoice                     => 'partp',
            $la_offer                               => 'offer',
            '2x'.$la_invoice_delivery_note . ' ' . $la_page_number_without          => 'invoi_deliv,invoi_deliv',
            '2x'.$la_invoice . ' + ' . $la_delivery_note . ' ' . $la_page_number_without   => 'invoi,invoi,deliv',
            $la_invoice . ' + ' . $la_delivery_note . ' ' . $la_page_number_without        => 'invoi,deliv',
        );
    }
    ?>
    <form class="inline"  method="post" action="<?php print $action; ?>">
        <?php

    print select_aus_array_auto($arr3, 'docum', 80, $active_dd);
        ?>
    <input type="hidden" name="id" value="<?php print $_SESSION['auf_id']; ?>">
    <input type="hidden" name="ext" value=".pdf">
    </form>
    <?php 
} // end func


/**
 * Hint: ORDER FINISHED and links inactive
 */
$condition_finished = $order['finished'] > 1;
$condition_deleted = $order['hide'] == 1;

if (    $condition_finished
        and ( 
                (       isset($_SESSION['anyway']) 
                    and $_SESSION['anyway'] != $_SESSION['auf_id']
                )
                or !isset($_SESSION['anyway'])
            ) 
    ) 
{
    $link->inactive();
    $active = false;
    $active2 = 'inactive';
    
}else{
    $active = true;
    $active2 = '';

}


    $arr = array(
        'tbl' => 'ord',
        'id' => $order['id'],
        'auf_id' => $order['id'],
        'file' => 'order_edit.php',
        );


    // ID OR NR
    if($adm['own_doc_number'] == 1) {
        $id_or_nr = $order['number'];
    }else {
        $id_or_nr = $order['id'];
    }
    
    if ($adm['own_doc_number'] == 1) {
        $id_nr = 'number';
    }else{
        $id_nr = 'id';
    }
    
    $inscription_edit = $id_or_nr . ' ' . $la_order . ' ' . $la_edit;
    $content_id_or_nr = $link->make_link('tbl_edit.php', $inscription_edit, $arr, 1)
                      . ' ';

    /**
     * Navigation
     */
    $content_navi = ' (ID'.$order['id'].') ';
    $nav = new Navi($use['db_e']);
    $nav->set_field($id_nr);
    $nav->set_id($order['id']);
    $nav->set_limit(3);
    $nav->get_last();
    $content_navi .= $nav->make_links_backward();
    $content_navi .= ' ' . $id_or_nr . ' ';
    $nav->get_next();
    $content_navi .= $nav->make_links_forward();
    
    
    /**
     *  color of row
     */
     // deleted
    if ($order['hide'] == 1) {
        require_once PROJECT_DOCUMENT_ROOT.'/css/deleted.inc.php';
        $format = ' class="bcolor2"';

    // finished
    } elseif ($order['finished'] > 1) {
        $format = ' class="bcolor_green"';
    // all other no format
    } else {
        $format = '';
    }
    
    /**
     * Order
     */
    $db = new Dbc($use['db_e']);
    $worker_username = $db->get_one_field($tbl_wor, $order['id_tbl_worker'], 'username');
    $content_order = $la_worker . ': ' . $worker_username
                . ' <br/> '
                . $order['order_description']
                . '<br/>'
                . $order['invoice_amount'] . ' ' . $adm['currency'];
     // Comment
    if ( !empty($order['comment1']) ) {
        $content_order_comment = $order['comment1'];
    }else{
        $content_order_comment = '';
    }
    
    
    /**
     *  Tax
     */
    $content_tax = '<div>' 
               . $bool2->set_content($la_on_off)
               . $la_tax_short;
    if($order['tax_on'] == 1) {
        $content_tax .= ' '
                   . $order['tax_rate_a'].'% und '. $order['tax_rate_b'].'%';
    }else{
        $content_tax .= '  ';
    }
    $content_tax .= $bool2->bool_link($order['tax_on'], $active)
                . '</div>';
    
    
    /**
     *  Brutto invoice
     */
    if ($active != true) {
        $bool2->set_inactive();
    }
    $bool2->set_id($_SESSION['auf_id']);
    $bool2->set_field_name('invoice_gross');
    $bool2->set_content('ein');
    $bool2->set_content($la_on_off);
    $bool2->set_content($la_invoice_gross);
    $bool2->set_bool_query($tbl);

    // Show gross only in case of tax_on = 1
    if ($order['tax_on'] == 1) {
        $content_invoice_gross = '<div> ' . $la_invoice_gross . ': '
                   . $bool2->bool_link($order['invoice_gross'], 1, $active2)
                   . '</div>';
    }else{
        $content_invoice_gross = '';
    }
     
    
    /**
     * Shipping
     */
    $link_menu = new Link_Menu();
    $e_a = $la_alter;
    $target = 'modul/ship/ship.php';
    $content_shipping = '<div>' . $la_shipping . ': '
               . $order['shipping_cost'] . ' '
               . $link_menu->insert_modul('ship', $target, $e_a, $arr)
               . '</div>';
    
    
    //  Print
    $content_print = ' <div>'
               . '<b>'.$la_print_preview.': </b><br/></div>';
    
    
    /**
     *  Client
     */
    $address = $db->get_row_as_array($tbl_adr, "id = " . $order['id_tbl_address']);
    $arr['tbl'] = 'adr';
    $arr['id'] = $address['id'];
    if (empty($address)) {
        $info->show_box($la_no_address_id);
        $free = new Link_Free_Edit();
        print $free->get_link();
        exit();
    }
    $content_client =  $la_client_id . ': ';
    if ($address['id_tbl_client'] > 0) {
        $arr['adr_id'] = $address['id'];
        $content_client .= $address['id_tbl_client'];
    }

    $content_client .= ' '
                    . $la_address_id . ': '
                    . $link->make_link('address_edit.php', $address['id'], $arr)
                    . ' <br>';

    if ($order['hide'] !=1) {
        $submit_text = $la_order_edit . " ...";
    } else {
        $submit_text = $la_hide_undo . " ...";
    }
    
    /**
     * Address for delivery
     */
    $lie = $db->get_row_as_array($tbl_adr, 'id='.$order['id_tbl_address_deliv']);
    $content_delivery_address = '<b>' . $la_delivery_address . ':</b>';
    if ($order['id_tbl_address_deliv'] == 0) {
        $e_a = $la_select_please;
    }else{
        $content_delivery_address .= $lie['id'] . ', ' . $lie['company'] . ', ' . $lie['surname'] . ' ';
        $e_a = $la_alter;
    }
    if (isset($file) and $file == 'order_edit.php') {
        $arr8 = array(
            'select_deliverer' => '', 
            'adr_id' => $address['id'],
            'src_file' => $file,
            'src_tbl' => 'adr',
            'new' => 1,
            'go' => 1,
            'src_tbl' => 'adr',
            );
        $content_delivery_address .= '<ul>'
                                  . $link->make_link('article_select.php', $e_a, $arr8)
                                  . '</ul>';

    }else{
        $content_delivery_address .= $e_a . '. Zum Auswhlen auf Register Positionen drcken.';
    }    
    
$html = new Html_Element();
    ?>
<div>
<span  style="font-size: 1.4em; font-weight: bold; width: 100%;">
    <?php print $content_id_or_nr; ?>
</span>  
    <?php print $content_navi; ?>
</div>
<table>
    <?php
    $html->tr1();
    $html->set_th_td(1);
    $html->tdh(true, $la_order_data); 
    $html->tdh(true, $la_tax_short . ', ' . $la_shipping . ', ' . $la_print); 
    $html->tdh(true, $la_client); 
    $html->tdh(true, $la_timeline, 'style="min-width: 135px;"'); 
    $html->tr2();
    $html->set_th_td(2);
    ?>
    <tr <?php print $format; ?>>
    <td style="width: 25%;">
            <?php print $content_order; ?>
        <p style="color: #8d5e5e; height: 40px; overflow:auto;">
            <?php print $content_order_comment; ?>
        </p>
    </td>
    <td style="width: 25%;">
        <?php
        print $content_tax;
        print $content_invoice_gross;
        print $content_shipping;
        print $content_print;
        // HTML print
        make_dropdown_print('h');
        // PDF print
        if ($use['mod_pdf'] == 1) {
            make_dropdown_print('p');
        }
        ?>
    </td>
    <td style="width: 25%;">
    <?php print $content_client; 
    // Class dok
    $invoice = new Doc_Html($use['db_e']);
    $invoice->set_data($_SESSION['auf_id'], 're');
    $invoice->set_output_format('h');
    print $invoice->make_html_address(false);
    
    ?>
    <div style=" border: 1px solid gray;">
    <?php print $content_delivery_address; ?>
    </div>
</td>
<td style="width: 33%;">
    <?php
    // Hint: email sended
    if (isset($_REQUEST['email']) and $_REQUEST['email'] == 'send') {
        $info->show_box('Die E-Mail wurde versendet und das Datum von heute eingetragen.', 'blue', '100%');
        print '<br/>';
    }
    
    
    /**
     * Timeline
     */

    // Array for get parameters
    $arr = array(
        'file' => $file,
        'tbl' => 'ord',
        'id' => $order['id'],
        'date_name' => 'date_offer'
        );
    $ziel2 = PROJECT_HTTP_ROOT.'date_edit.php';
    $content_date_1 = substr($order['date_insert'], 0, 10) . ' '; 
    
    
    /**
     *  Offer
     */
    $file2 = PROJECT_DOCUMENT_ROOT.'/modul/email/email.php';
    if( is_file($file2) and $use['mod_email'] == 1 ) {
        $img_vers = '';
    }else{
        $img_vers = '2';
    }
    $target_mail2 = '/modul/email/email.php';
    $img = '<img src="' . PROJECT_HTTP_ROOT . 'image/mail' . $img_vers . '.jpg" border="none">';
    $content_offer_1 = show_date($order['date_offer']) . ' ';
    
    $content_offer_2 = $link_menu->insert_modul('email', $target_mail2, $img, 'dok=offer');
    
    $offer_1 = strtoupper(substr($la_offer, 0, 2));
    $offer_2 = substr($la_offer, 2);
    $content_offer_3 = ' '.$link->make_link($ziel2, $offer_1, $arr, $la_offer)
                     . $offer_2 . " <br/>";
    
    /**
     *  Order confirmation
     */
    $content_order_conf_1 = show_date($order['date_order_conf']) . ' ';
    $content_order_conf_2 = $link_menu->insert_modul('email',  $target_mail2, $img, 'dok=confi')
                            . ' ';
    $arr['date_name'] = 'date_order_conf';
    if ($order['date_order_conf'] > 1) {
        $link->set_class('bcolor_blue');
    }else{
        $link->set_class('action');
    }
    $order_conf_1 = strtoupper(substr($la_order_conf, 0, 2));
    $order_conf_2 = substr($la_order_conf, 2);
    $content_order_conf_3 = $link->make_link($ziel2, $order_conf_1, $arr, $la_order_conf)
                          . $order_conf_2;   
    
    
    /**
     *  Delivery
     */
    $content_delivery_1 = show_date($order['delivered']) . ' ';
    $content_delivery_2 = $link_menu->insert_modul('email',  $target_mail2, $img, 'dok=deliv');
    $arr['date_name'] = 'delivered';
    if ($order['delivered'] > 1) {
        $link->set_class('bcolor_blue');
    }else{
        $link->set_class('action');
    }
    $deliv_1 = strtoupper(substr($la_delivery_note, 0, 2));
    $deliv_2 = substr($la_delivery_note, 2);
    $content_delivery_3 = $link->make_link($ziel2, $deliv_1, $arr, $la_delivery_note)
                            . $deliv_2;  
    
    
    /**
     *  Invoice
     */
    $content_invoice_1 = show_date($order['date_invoice']) . ' ';
    $arr['date_name'] = 'date_invoice';
    if ($order['date_invoice'] > 1) {
        $link->set_class('bcolor_blue');
    }else{
        $link->set_class('action');
    }
    $invoice_1 = strtoupper(substr($la_invoice, 0, 2));
    $invoice_2 = substr($la_invoice, 2);
    $content_invoice_3 = $link->make_link($ziel2, $invoice_1, $arr, $la_invoice)
                        . $invoice_2 . '<br/>';
    
    
    /**
     *  Reminder
     */
    $content_reminder_1 = show_date($order['date_reminder_1']) . ' ';
    $content_reminder_2 = $link_menu->insert_modul('reminder', 'modul/reminder/reminder.php', $img, 'id='.$_SESSION['auf_id']);
    $arr['date_name'] = 'date_reminder_1';
    if ($order['date_reminder_1'] > 1) { 
        $link->set_class('bcolor_blue');
    }else{
        $link->set_class('action');
    }
    $content_reminder_3 = $link->make_link($ziel2, $la_reminder, $arr, $la_reminder);
    
    /**
     *  Payed
     */
    $content_payed_1 = show_date($order['payed']) . ' ';
    $content_payed_2 = $link_menu->insert_modul('email', $target_mail2, $img, 'dok=be');
    $arr['date_name'] = 'payed';
    if ($order['payed'] > 1) { $link->set_class('bcolor_blue');

    }else{
        $link->set_class('action');
    }
    $content_payed_3 = $link->make_link($ziel2, $la_payed, $arr, $la_payed) . '<br>';    
    
    
    /**
     *  Finished
     */
    $content_finished_1 = show_date($order['finished']) . ' ';
    $arr['date_name'] = 'finished';
    if ($condition_finished) { $link->set_class('bcolor_blue');

    }else{
        $link->set_class('action');
    }
    $content_finished_3 = $link->make_link($ziel2, $la_finished, $arr);
    ?>
    
    
    
<table style="width: auto;">
    <?php
    $condition_email = ($use['mod_email'] == 1);
    $html->tr1();
        $html->tdh(true, $content_date_1);
        $html->tdh($condition_email, '--');
        $html->tdh(true, $la_date_of_receipt);
    $html->tr2();
    $html->tr1();
        $html->tdh(true, $content_offer_1);
        $html->tdh($condition_email, $content_offer_2);
        $html->tdh(true, $content_offer_3);
    $html->tr2();
    $html->tr1();
        $html->tdh(true, $content_order_conf_1);
        $html->tdh($condition_email, $content_order_conf_2);
        $html->tdh(true, $content_order_conf_3);
    $html->tr2();
    $html->tr1();
        $html->tdh(true, $content_delivery_1);
        $html->tdh($condition_email, $content_delivery_2);
        $html->tdh(true, $content_delivery_3);
    $html->tr2();
    $html->tr1();
        $html->tdh(true, $content_invoice_1);
        $html->tdh($condition_email, '--');
        $html->tdh(true, $content_invoice_3);
    $html->tr2();
    $html->tr1();
        $html->tdh(true, $content_reminder_1);
        $html->tdh($condition_email, $content_reminder_2);
        $html->tdh(true, $content_reminder_3);
    $html->tr2();
    $html->tr1();
        $html->tdh(true, $content_payed_1);
        $html->tdh($condition_email, $content_payed_2);
        $html->tdh(true, $content_payed_3);
    $html->tr2();
    
/**
 *  Part payment
 */
if ($order['part_pay_amount'] > 0) {
    
    $content_part_pay_head = '<b>' . $la_partpay . ' aktiv</b><br/>';
    $content_part_pay_date_1 = show_date($order['date_part_pay']) . ' ';
    
    $arr['date_name'] = 'date_part_pay';
    $content_part_pay_date_3 = $link->make_link($ziel2, ' '.$la_date, $arr);
    
    $content_part_pay_payed_1 = show_date($order['part_pay_payed']) . ' ';
    
    $arr['date_name'] = 'part_pay_payed';
    if ($order['part_pay_payed'] > 1) { 
        $link->set_class('bcolor_blue');
    }else{
        $link->set_class('action');
    }
    $content_part_pay_payed_3 = $link->make_link($ziel2, 'Abschlag '.$la_payed, $arr)
                               . '<br>';
    
        $html->tr1();
        ?>
        <td colspan="3"><?php print $content_part_pay_head; ?>
        </td>
        <?php
        $html->tr2();
        $html->tr1();
            $html->tdh(true, $content_part_pay_date_1);
            $html->tdh($condition_email, '--');
            $html->tdh(true, $content_part_pay_date_3);
        $html->tr2();
        $html->tr1();
            $html->tdh(true, $content_part_pay_payed_1);
            $html->tdh($condition_email, '--');
            $html->tdh(true, $content_part_pay_payed_3);
        $html->tr2();
} // end part_pay_amount > 0

    $html->tr1();
        $html->tdh(true, $content_finished_1);
        $html->tdh($condition_email, '--');
        $html->tdh(true, $content_finished_3);
    $html->tr2();
    ?>
</table>
</td>
</tr>
</table>
<?php


/**
 * Hint: order finished
 */
if ($condition_finished) {
    $link_active = new Link();
    $text = $la_order_finished.' ';
    if (isset($_SESSION['anyway'])) {
        $arr6 = array('new' => 1,);
        $text .= $link_active->make_link($_SERVER['PHP_SELF'], $la_record_lock, $arr6);
        
    }else{
        $arr6 = array('anyway' => $_SESSION['auf_id'],);
        $text .= $link_active->make_link($_SERVER['PHP_SELF'], $la_record_unlock, $arr6);
    }
    $info->show_box($text);
}

/**
 * Hint: order hidden
 */
if ($condition_deleted) {
    $text = $la_order_deleted.' ';
    $info->show_box($text, 'red', '90%');
}

/**
 * Tabs
 */
$tab = new Tab();
if (isset ($_SESSION['file'])) {
    $arr = array('file' => $_SESSION['file']);
}
$arr_target = array(
    'order_edit.php', 
    'order_doc.php', 
    'order_doc.php',
    'order_doc.php', 
    'order_doc.php', 
    );
$arr_inscription = array(
    $la_positions, 
    $la_offer, 
    $la_order_conf,
    $la_delivery_note, 
    $la_invoice, 
    );
$arr_dok = array( 
    '', 
    'offer', 
    'confi', 
    'deliv', 
    'invoi', 
    );

/**
 *  Assumption of costs tab
 * $todo condition label !
 */
if (is_dir(PROJECT_DOCUMENT_ROOT.'/modul/partpay') and $use['mod_label'] == 1) {
    array_push($arr_target, 'order_doc.php');
    array_push($arr_inscription, $la_kue);
    array_push($arr_dok, 'assum');
}

/**
 *  Part payment tab
 * $todo condition label !
 */
if (is_dir(PROJECT_DOCUMENT_ROOT.'/modul/partpay') and $use['mod_label'] == 1) {
    array_push($arr_target, 'order_doc.php');
    array_push($arr_inscription, $la_partpay);
    array_push($arr_dok, 'partp');
}

// Label tab
if (is_dir(PROJECT_DOCUMENT_ROOT.'/modul/label') and $use['mod_label'] == 1) {
    array_push($arr_target, 'order_doc.php');
    array_push($arr_inscription, $la_labels);
    array_push($arr_dok, 'eti');
}

// Timeline
if (is_dir(PROJECT_DOCUMENT_ROOT.'/modul/timeline') and $use['mod_label'] == 1 
        and (       $use['id'] < 3 
                or  $use['id'] == 13
                or  $use['id'] == 18)) 
{
    array_push($arr_target, 'modul/timeline/timeline.php');
    array_push($arr_inscription, $la_timeline);
    array_push($arr_dok, 'tim');
}

$tab->set_array_target($arr_target);
$tab->set_array_inscription($arr_inscription);
$tab->set_current_file($file);
if (isset($document)) {
    $tab->set_document($document);
}
$tab->set_arr_param_for_document($arr_dok);
print $tab->make_tabs();