<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/**
 * Configuration file for db tables and fields
 *
 * @since 2010-12
 */

// german
if (isset ($_SESSION['lang']) and $_SESSION['lang'] == 'de') {
    require_once PROJECT_DOCUMENT_ROOT . '/lang/german.inc.php';
    $tbl_uni =      DB_NAME . '.tbl_0_unit_de'; 
    
// english
}elseif(isset ($_SESSION['lang']) and $_SESSION['lang'] == 'en') {
    require_once PROJECT_DOCUMENT_ROOT . '/lang/english.inc.php';
    $tbl_uni =      DB_NAME . '.tbl_0_unit_en'; 
    
// anything else
}else{
    require_once PROJECT_DOCUMENT_ROOT . '/lang/german.inc.php';
    $tbl_uni =      DB_NAME . '.tbl_0_unit_de'; 
}

// Declaration of tables, pretago hosting
if (isset ($_SESSION['use_id'])) {
    $use_id2 = $_SESSION['use_id'];

    $tbl_workflow = DB_NAME . '.tbl_0_workflow';
    $tbl_adr =      'tbl_' . $use_id2 . '_address';
    $tbl_workflow_ite =  DB_NAME . '.tbl_0_workflow_item';
    $tbl_adm =      'tbl_' . $use_id2 . '_admin'; 
    $tbl_cal =      'tbl_' . $use_id2 . '_calc'; 
    $tbl_cal_fit =  'tbl_' . $use_id2 . '_calc_fitting';
    $tbl_cal_lis =  'tbl_' . $use_id2 . '_calc_list';
    $tbl_cal_mat =  'tbl_' . $use_id2 . '_calc_material'; 
    $tbl_cal_tim =  'tbl_' . $use_id2 . '_calc_time'; 
    $tbl_cat =      'tbl_' . $use_id2 . '_category'; 
    $tbl_cli =      'tbl_' . $use_id2 . '_client';   
    $tbl_cli_pro =  'tbl_' . $use_id2 . '_client_product';  
    $tbl_com =      'tbl_' . $use_id2 . '_complaint';  
    $tbl_con =      'tbl_' . $use_id2 . '_convention';  
    $tbl_cou =      DB_NAME . '.tbl_0_country'; 
    $tbl_err =      EH_DB_TABLE; 
    $tbl_exp =      'tbl_' . $use_id2 . '_expense'; 
    $tbl_hel =      DB_NAME . '.tbl_0_help'; 
    $tbl_hou =      'tbl_' . $use_id2 . '_hourly_rate';
    $tbl_let =      'tbl_' . $use_id2 . '_letter';
    $tbl_log =      DB_NAME . '.tbl_0_login2'; 
    $tbl_ord =      'tbl_' . $use_id2 . '_order';
    $tbl_ord_ite =  'tbl_' . $use_id2 . '_order_item';
    $tbl_pro =      'tbl_' . $use_id2 . '_product';
    $tbl_pri =      'tbl_' . $use_id2 . '_price'; 
    $tbl_pri_pub =  DB_NAME . '.tbl_0_price';
    $tbl_tex =      'tbl_' . $use_id2 . '_text';
    $tbl_tim =      'tbl_' . $use_id2 . '_timeline';
    $tbl_use =      'tbl_0_user'; 
    $tbl_wor =      'tbl_' . $use_id2 . '_worker'; 
}

$sty_right_yellow = 'align="right" class="bcolor_yellow"';


/**
 * Workflow
 */
$abl_fel_input = array('id', 'description');
$abl_fel_such = array('id', 'description');
$abl_fel_output = array('id', 'description');

/**
 * Workflow_item
 */
$abl_pos_fel = array(
    'id',
    'id_tbl_arbeitsablauf',
    'item',
    'schritt' 
    );
    $abl_pos_fel_input = $abl_pos_fel;
    $abl_pos_fel_output = $abl_pos_fel;

/**
 * Adress
 */
$adr_fel_input = array(
    'id' ,
    'company' ,
    'id_tbl_salutation' ,
    'forename' ,
    'surname' ,
    'addition' ,
    'street' ,
    'postcode' ,
    'city'  ,
    'id_tbl_country',
    'date_insert' ,
    'phone' ,
    'fax' ,
    'mobil' ,
    'email' ,
    'comment1' ,
    'deliverer' ,
    'hide' ,
    'delivery_address_on' ,
    'tax_id',
        );
$adr_fel_output = array(
    'id' ,
    'id_tbl_client',
    'IF(CHAR_LENGTH(company)<1,CONCAT(surname," ",forename),company)',
    "IF(CHAR_LENGTH(company)<1,'',surname)",
    'postcode' ,
    'city' ,
    'street' ,
    'id_tbl_country' ,
    'comment1' ,
    'hide',
    );

/**
 * Product
 */
$pro_fel_input = array(
    'id' ,
    'id_tbl_category' ,
    'short' ,
    'description' ,
    'sales_price' ,
    'date_insert' ,
    'id_tbl_unit' ,
    'tax_a_b' ,
    'comment1' ,
    'img_url' ,
    );
$pro_fel_output = array(
    'art.id' ,
    'art.hide',
    'category' ,
    'short' ,
    'description',
    'sales_price',
    'date_insert',
    'unit',
    'img_url',
);


/**
 * Order
 */
$ord_fel_input = array(
    'id',
    'number',
    'order_description',
    'invoice_amount',
    'tax_rate_a' ,
    'tax_rate_b',
    'tax_a',
    'tax_b',
    'your_mark' ,
    'id_tbl_address' ,
    'id_tbl_address_deliv' ,
    'id_tbl_worker',
    'time_delivery' ,
    'comment1' ,
    'shipping_cost',
    'time_payment' ,
    'time_payment_add' ,
    'part_pay_amount' ,
    'date_insert' ,
    'date_offer',
    'date_order_conf',
    'date_assumption_costs',
    'delivered',
    'date_invoice' ,
    'date_part_pay' ,
    'part_pay_payed' ,
    'date_reminder_1' ,
    'date_reminder_2' ,
    'payed',
    'finished',
    'tax_on',
    'delivered_on' ,
    'invoice_gross' ,
    'shipping_cost_always' ,
    'hide'
    );
$ord_fel_output = array(
    'auf.id' ,
    'number' ,
    'order_description' ,
    'id_tbl_client' ,
    'IF(CHAR_LENGTH(company)<1,CONCAT(adr.surname,"\, ", adr.forename), company)',
    'invoice_amount' ,
    'username' ,
    'auf.date_insert' ,
    'auf.hide' ,
    'delivered' ,
    'payed' ,
        );

/**
 * Complaint
 */
$com_fel_input = array(
    'id',
    #'number',
    'order_description',
    'invoice_amount',
    'tax_rate_a' ,
    'tax_rate_b',
    'tax_a',
    'tax_b',
    'your_mark' ,
    'id_tbl_address' ,
    'id_tbl_address_deliv' ,
    'id_tbl_worker',
    'time_delivery' ,
    'comment1' ,
    'shipping_cost',
    'time_payment' ,
    'time_payment_add' ,
    'part_pay_amount' ,
    'date_insert' ,
    'date_offer',
    'date_order_conf',
    'date_assumption_costs',
    'delivered',
    'date_invoice' ,
    'date_part_pay' ,
    'part_pay_payed' ,
    'date_reminder_1' ,
    'date_reminder_2' ,
    'payed',
    'finished',
    'tax_on',
    'delivered_on' ,
    'invoice_gross' ,
    'shipping_cost_always' ,
    'hide'
    );
$com_fel_output = array(
    'com.id' ,
    #'number' ,
    'order_description' ,
    'id_tbl_client' ,
    'IF(CHAR_LENGTH(company)<1,CONCAT(adr.surname,"\, ", adr.forename), company)',
    'invoice_amount' ,
    'com.date_insert' ,
    'com.hide' ,
    'delivered' ,
    'payed' ,
        );


/**
 * Order item
 */
$ord_ite_fel_input = array(
    'id' ,
    'item' ,
    'id_tbl_order' ,
    'date_insert',
    'amount' ,
    'description' ,
    'sales_price' ,
    'hide',
    );
$ord_ite_fel_output = array(
    'aufp.id' ,
    'id_tbl_order' ,
    'amount' ,
    'description' ,
    'sales_price' ,
    'item' ,
    'id_tbl_product' ,
    'auf.date_insert',
    'aufp.hide' ,
    );

/**
 * Client product
 */
$cli_pro_fel_output = array(
    'art.id' ,
    'art.description' ,
    'kuna.hide' ,
    );


/**
 * Expense
 */
$exp_fel_input = array(
    'id',
    'date2',
    'expense',
    'invoice_amount',
    'comment1',
    'hide',
    'delivered',
    'payed',
    'material',
    'id_tbl_address',
        );
$exp_fel_output = array(
    'aus.id',
    'aus.date2' ,
    'aus.delivered' ,
    'aus.payed' ,
    'aus.comment1' ,
    'aus.hide',
    'expense' ,
    'company' ,
    'id_tbl_address' ,
    'invoice_amount',
        );

/**
 * Operator
 */
 $wor_fel_input = array(
    'id',
    'username',
    'surname',
    'forename',
    'background',
    'hide',
    'date_insert',
     );
 $wor_fel_output = $wor_fel_input;

 
/**
 * Calc fitting
 */
$cal_fit_fel_input = array(
    'id',
    'id_tbl_order_item',
    'item',
    'description',
    'amount',
    'id_tbl_unit',
    'sales_price',
    'comment1',
    'hide',
    'amount_fact',
    );

// setzt b.id an den Anfang des arrays
$cal_fit_fel_output = array('bes.id' => $la_id) + $cal_fit_fel_input;
unset($cal_fit_fel_output['id']);


/**
 * Letter
 */
$let_fel_input = array(
    'id',
    'id_tbl_address',
    'id_tbl_order',
    'id_tbl_worker',
    'date_insert',
    'id_tbl_address',
    'reference',
    'your_mark',
    'salutation',
    );
$let_fel_output = array(
    'bri.id',
    "IF(CHAR_LENGTH(company)<1,CONCAT(surname,'\,',forename),company)",
    'id_tbl_order',
    'reference',
    'letter_text',
    'typ',
     );


/**
 * Error
 */
$err_fel_input = array(
    'id',
    'user',
    'error',
    'script',
    'line',
    'date_insert',
    'hide'
     );
$err_fel_output = $err_fel_input;


/**
 * Login
 */
$log_fel_input = array(
    'id',
    'id_tbl_user',
    'email',
    'version',
    'ip',
    'http_user_agent',
    'date_insert',
    'hide',
     );
$log_fel_output = $log_fel_input;


/**
 * Help
 */
$hel_fel_input = array(
    'id',
    'thema',
    'description' ,
    'hide' 
    );
$hel_fel_output = $hel_fel_input;


/**
 * Convention
 */
$con_fel_input = array(
    'id',
    'thema',
    'description' ,
    'hide' 
    );
$con_fel_output = $con_fel_input;


/**
 * Calc list
 */
$cal_lis_fel_input = array(
    'id' ,
    'id_tbl_order_item' ,
    'item',
    'id_tbl_calc_material',
    'amount' ,
    'description' ,
    'l' ,
    'w' ,
    't' ,
    'edge' ,
    'comment1' ,
    );
$cal_lis_fel_output = $cal_lis_fel_input;


/**
 * Calc
 */
$cal_fel_input = array(
    'id',
    'id_tbl_order_item' ,
    'overheads_material',
    'risk_profit' ,
    'split' ,
    );
$cal_fel_output = array(
    'kal.id',
    'kal.hide' ,
    'id_tbl_order' ,
    'item' ,
    'description' ,
    'overheads_material' ,
    'risk_profit' ,
    'sales_price',
    );

/**
 * Category
 */
$cat_fel_input = array(
    'id',
    'category' ,
    'tbl_product' ,
    'tbl_price',
    'hide',
    );
$cat_fel_output = array(
    'id' ,
    'category' ,
    'hide' ,
    );


/**
 * Calc material
 */
$cal_mat_fel_input = array(
    'id',
    'id_tbl_order_item',
    'item' ,
    'waste' ,
    'id_tbl_unit' ,
    'thick',
    'description',
    'sales_price',
    'edge',
    );

$cal_mat_fel_output = $cal_mat_fel_input;


/**
 * Price
 */
$pri_fel_input = array(
    'id',
    'id_tbl_category' ,
    'short' ,
    'description',
    'purchase_price',
    'percent_to_purchase_price',
    'sales_price',
    'thick' ,
    'material' ,
    'date_insert',
    'order_code',
    'id_tbl_address',
    'id_tbl_unit',
    'hide',
    'img_url',
    );
$pri_fel_output = array(
    'pre.id',
    'pre.date_insert' ,
    'pre.hide' ,
    'category' ,
    'short',
    'description',
    'purchase_price' ,
    'sales_price' ,
    'thick',
    'company',
    'unit',
    );


/**
 *  Price public
 */
$pri_pub_fel_output = array(
    'pre.id',
    'category' ,
    'short' ,
    'description',
    'purchase_price',
    'sales_price',
    'thick',
    'pre.date_insert',
    'unit',
    'pre.hide',
    );
$pri_pub_fel_input = $pri_fel_input;


/**
 * Hourly_rate
 */
$hou_fel_input = array(
    'id',
    'short',
    'money_hour',
    'hide',
    );
$hou_fel_output = $hou_fel_input;


/**
 * Text
 */
$tex_fel_input = array(
    'id',
    'short',
    'text_block',
    'hide',
    );
$tex_fel_output = $tex_fel_input;


/**
 * Time
 */
$cal_tim_fel_input = array(
    'id' ,
    'id_tbl_order_item',
    'item',
    'description' ,
    'h_planned' ,
    'h_fact',
    'id_tbl_hourly_rate',
    'comment1',
    'hide',
        );
$cal_tim_fel_output = $cal_tim_fel_input;


/**
 * Timeline
 */
$tim_fel_input = array(
    'id' ,
    'description',
    'date_insert' ,
    'comment1',
    'hide',
        );
$tim_fel_output = $tim_fel_input;

/**
 * Array with special field names or functions
 * Used from class Query() for alias definition
 */
$arr_fields_alias = array(
    'adr.id' => $la_address_id,
    'auf.id' => $la_order_id,
    'auf.hide' => $la_hidden,
    'art.id' => $la_product_id,
    'art.hide' => $la_hidden,
    'company' => $la_company,
    'IF(CHAR_LENGTH(company)<1,CONCAT(adr.surname,"\, ", adr.forename), company)' => $la_client,
    'IF(CHAR_LENGTH(company)<1,CONCAT(surname," ",forename),company)' => $la_client,
    "IF(CHAR_LENGTH(company)<1,'',surname)" => $la_contact_person,
    'aufp.hide' => $la_hidden,
    'aufp.id' => $la_id,
    'auf.date_insert' => $la_date,
    'aufp.hide' => $la_hidden,
    'aus.id' => $la_id,
    'aus.date2' => $la_date,
    'aus.delivered' => $la_delivered,
    'aus.payed' => $la_payed,
    'aus.comment1' => $la_comment1,
    'aus.hide' => $la_hidden,
    'bes.id' => $la_id,
    'bri.id' => $la_letter_id,
    'kal.id' => $la_id,
    'kal.hide' => $la_hidden,
    'number' => $la_order_nr,
    'pre.id'=> $la_id,
    'pre.date_insert' => $la_date,
    'pre.hide' => $la_hidden,
    "IF(CHAR_LENGTH(company)<1,CONCAT(surname,'\,',forename),company)" => $la_client,
    // calc
    'hol.item' => $la_item,
    'zei.item' => $la_item,
    "CONCAT(SUBSTRING(mat.description,1,6),'_', SUBSTRING(mat.thick,-4,2))" => $la_material,
    "FORMAT(sales_price+(sales_price/100*waste),2)" => 'eur/qm',
    "FORMAT( (( l * w / 1000000 * amount) + (mat.waste*l*w/1000000*amount/100)) * sales_price,2)" => $la_total_price,
    "h_planned * money_hour" => $la_total,
    'amount * sales_price' => $la_total,
);
