<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


/**
 * Script for showing input fields for different tables
 * 
 */
require_once 'common.php';


// Initial variable
$array = array('auf_pos_id');
initial_var($array);

/**
 * Form after submit
 */
// db --------------------------------------------------------------------------
if(isset($_REQUEST['insert_data'])  or isset($_REQUEST['posi_hinzu']) ) {

    // Table order
    if($tbl == $tbl_ord) {
        // new number to jump to the fitting order
        $auf_id = $db->get_max($tbl_ord, 'number') + 1;
        $file = 'order_edit.php?auf_id=' . $auf_id;
    }else{
        $file = 'query.php';
    }

    // Insert data and get last_insert_id
    $in = $db->insert_row($tbl);

    /**
     * Address
     * insert row and put adr_id into tbl_cli
     */
    if ($tbl == $tbl_adr and $in > 0) {
        $max_id4 = $db->get_max($tbl_adr, 'id');
        $data = $db->make_array_for_sql($tbl_cli);
        $db->insert_array($tbl_cli, $data);
        $sql = "
            UPDATE $tbl_cli
            SET id_tbl_address =  $max_id4 
            WHERE id = LAST_INSERT_ID()";
        $db->do_sql($sql);

        // Forwarding to client not to address
        $_SESSION['tbl'] = 'adr';
    }
    
    /**
     * Table client
     * insert row and put adr_id into tbl_cli
     */
    if ($tbl == $tbl_cli and $in > 0) {
        $sql = "
            UPDATE $tbl_adr
            SET id_tbl_client =  {$_REQUEST['client_no']}
            WHERE id = {$_REQUEST['id']}";
        $db->do_sql($sql);

        // Forwarding to client not to address
        $_SESSION['tbl'] = 'adr';
    }

    /**
     * Set sales price
     */
    $max_id = $db->get_max($tbl, 'id');
    if($tbl == $tbl_pri) { // sales_price ver?ndern
        $sql = "UPDATE $tbl
        SET sales_price = (purchase_price + (purchase_price / 100 * percent_to_purchase_price))
        WHERE id = $in";
        $db->do_sql($sql);
     }


     /**
      * Standard values for order
      */
    if($tbl == $tbl_ord) {
        $array_with_fields4 = array(
            'offer_top',
            'offer_bottom',
            'order_conf_top',
            'order_conf_bottom',
            'delivery_top',
            'delivery_bottom',
            'invoice_top',
            'invoice_bottom',
            'assumption_costs_top',
            'assumption_costs_bottom',
            'time_payment',
            'time_payment_add',
            'shipping_cost_always',
            'invoice_gross',
            'tax_on',
            'delivered_on',
            );
        // Make query
        $sql = "UPDATE $tbl SET ";
        foreach ($array_with_fields4 as $value) {
            $sql .= $value . "='" . $adm[$value] . "',";
        }
        $sql = substr($sql, 0, -1);
        $sql .= "WHERE id = $max_id";
        $db->do_sql($sql);
     }
     
    $go = new Go_Forward();
    $go->go_to_target($_SESSION['file'],'tbl=' . $_SESSION['tbl']
         . '&value1=' . $max_id . '&new=3&page=1');
// end db -----------------------------------------------------------------------

/**
 * Form before submit
 */
}elseif (!isset($_REQUEST['insert_data'])) {

    HTML::printHead($css);

    // Switch for cursor position
    if (isset($_REQUEST['tbl'])) {
        
        if ($_REQUEST['tbl'] == 'adr') {
            $form_field = 'teo.company';
            
        }elseif($_REQUEST['tbl'] == 'let') {
            $form_field = 'teo.reference';
            
        }elseif($_REQUEST['tbl'] == 'cat') {
            $form_field = 'teo.category';
            
        }elseif($_REQUEST['tbl'] == 'tex' 
                or $_REQUEST['tbl'] == 'pro' 
                or $_REQUEST['tbl'] == 'pri' )
        {
            $form_field = 'teo.short';
            
        }elseif($_REQUEST['tbl'] == 'ord') {
            $form_field = 'teo.order_description';
            
        }elseif($_REQUEST['tbl'] == 'exp') {
            $form_field = 'teo.expense';
            
        }elseif($_REQUEST['tbl'] == 'hil_the') {
            $form_field = 'teo.thema';
            
        }else{
            $form_field = '';
        }
        
    }else{
        $form_field = '';
    }

    HTML::printBody($form_field);
    HTML::printHeadline($headline);


    require_once 'include/bar_common.inc.php';
    
    
    ?>
<!-- link calendar files  -->
<script language="JavaScript" src="modul/calendar/calendar_db.js"></script>
<link rel="stylesheet" href="modul/calendar/calendar.css">
<?php

/**
 *  Select category
 */
if (        ($tbl == $tbl_pri or $tbl == $tbl_pro) 
        and (!isset($_POST['category_selected']) 
        and !isset($_REQUEST['insert_data'])) ) 
{
    ?>
    <div style="width:40%;" class="center">

    <h1><?php print $la_categorie_select; ?></h1>
    <?php
    $qry_category = "
        SELECT id, category 
        FROM $tbl_cat
        WHERE hide != 1";

    $result_category = $db->query($qry_category);
    
    while($category = $db->fetch_array($result_category)) {
        ?>
        <form method="post" name="teo" action="tbl_insert.php">
        <?php
        // Hidden inputs
        if (!isset($category['id'])) { $category['id'] = '';}
            
        // Initial session var if is'nt set
        initial_var(array('adr_id', 'file', 'tbl'));
            
            $arr = array(
                'tbl'               => $_SESSION['tbl'],
                'file'              => $_SESSION['file'],
                'id_tbl_category'   => $category['id'],
                'adr_id'            => $_SESSION['adr_id'],
                'id'                => 5,
            );      
            $html = new Html_Element();
            print $html->make_hidden_input_from_array($arr);
        ?>
            <input type="submit" name="category_selected" value="<?php print $category['category']; ?>">
            <br>
        </form>
        <?php
    }
    ?>
    </div>
    <?php
    exit;
    
    
}else{
    ?>
    <div style="width:60%;" class="center">
    <form method="post" name="teo">
    <?php 
}

    /**
     * Headline new order, expense, price
     */
    if (($tbl == $tbl_ord or $tbl == $tbl_exp or $tbl_pri) and
        (isset($_REQUEST['adr_id']) and $_REQUEST['adr_id'] != '') ) 
    {
        if ($tbl == $tbl_ord) {
            $message = $la_new_order_for_client;
        }elseif ($tbl == $tbl_exp) {
            $message = $la_new_expense;
        }elseif ($tbl == $tbl_pri) {
            $message = $la_new_price;
        }elseif ($tbl == $tbl_tex) {
            $message = $la_new_letter;
        }else{
            $message = $la_new;
        }
        
        /**
         * Get client data as array like: $kun3[surname] etc.
         */
        $address = $db->get_row_as_array($tbl_adr, "id = ".$_REQUEST['adr_id']);
        $address_details = "id(" . $address['id'] . "): " . $address['company'] . ", "
                         . $address['surname'] . ", " . $address['postcode'] . ' ' 
                         . $address['city'] ;
        ?>
        <br>
        <h1>
            <?php print $message . ':'; ?>
        </h1>
        <h1>
            <?php print $address_details; ?>
        </h1>
        <?php
    }

    // New calculation: check settings
    if($tbl == $tbl_cal) {
        $info->show_box($la_new_calc_settings);
    }

// Get field array, for example: 'auf_fel_input'
$felder_for_last =  get_input_output_array('input');

    /**
     * Client nr
     */
    if($tbl == $tbl_adr) {
        // Get max address id
        $address_id_max = $db->get_max($tbl_adr, 'id_tbl_client');

        // New client id (max + 1)
        $address_id_new = $address_id_max +1;

        // Hidden input
        $array_assoc_data = array(
            'id_tbl_client' => $address_id_new,
            'client_no' => $address_id_new,
        );
        print $html->make_hidden_input_from_array($array_assoc_data);
    }

    
    $form = new Db_Form($use['db_e']);
    $field_content = '';


    // Hidden fields
    $arr_hidden_fields = array(   
        'id_tbl_address',
        'id_tbl_order',
        'id_tbl_order_item',
        'tax_rate_a',
        'tax_rate_b',
        'invoice_gross',
        'id_tbl_worker',
        'new',
        'id_tbl_category',
        );
    
    $form->set_hidden_fields($arr_hidden_fields);
    if (isset($_GET['adr_id'])) {
        $adr_id = $_GET['adr_id'];
    }else{
        $adr_id = '';
    }
    
    
    if (isset($_REQUEST['id_tbl_category'])) {
        $category_value = $_REQUEST['id_tbl_category'];
    }else{
        $category_value = '';
    }
    // auf_id
    if (isset($_SESSION['auf_id'])) {
        $auf_id = $_SESSION['auf_id'];
    }else{
        $auf_id = '';
    }
    // Hidden values
    $arr_hidden_values = array(  
        $adr_id ,
        $auf_id,
        $_SESSION['auf_pos_id'],
        $adm['tax_rate_a'],
        $adm['tax_rate_b'],
        $adm['invoice_gross'],
        $_SESSION['bea_id'],
        3,
        $category_value,
        );
    
    $form->set_hidden_values($arr_hidden_values);

    // Skipped fields
    $arr_skipped_fields_insert = array(     
         'id', // Never change the ID
         'date_order_conf',
         'salutation',
         'payed',
         'invoice_gross',
         'belegart',
         $la_product_id ,
         $la_id ,
         'id_tbl_client',
         'id_tbl_address_deliv',
         'hide',
         'date_insert',
         'date_letter',
         'date_reminder_1',
         'date_reminder_2',
         'date_offer',
         'date_assumption_costs',
         'finished',
         'letter_text',
         'tax_on',
         'tax_rate',
         'tax_a',
         'tax_b',
         'delivered',
         'delivered_on',
         'date_part_pay',
         'part_pay_amount',
         'invoice_amount',
         'date_invoice',
         'vers,',
         'shipping_cost',
         'shipping_cost_always',
         'time_payment',
         'time_payment_add',
         'typ',
         'part_pay_payed', 
       );
    
    // Show invoice_amount in tbl expense
    if ($_SESSION['tbl'] == 'exp') {
        unset ($arr_skipped_fields_insert[27]); // invoice_amount
    }
    $form->set_skipped_fields($arr_skipped_fields_insert);
    
    // Print insert fields
    $form->set_fields($felder_for_last);
    $form->set_tbl_and_id($tbl);
    $form->iterate_fields();
        
    // Print hidden check_id_field
    check_id_field();
    ?>
    <br/>
    <input type="submit" name="insert_data" value="<?php print $la_save; ?>">
    </form>
    </p>
    <?php
        
    if($tbl == $tbl_exp) {
        print '<h1>' . $la_last_records . '</h1>';
        /**
         * Display last inserts
         */
        // create variable for felder-array  f.i. 'auf_fel_input'
        $arr_fields =  get_input_output_array('output');
        
        $qry = new Query();
        $qry->set_fields($arr_fields);
        $qry->set_order_field('id');
        $qry->set_order_direction('DESC');
        $qry->set_table_or_relation($rel_expense_address);
        $query = $qry->get_query();

        // Show table
        $tblc = new Tbl( $use['db_e']);
        $tblc->set_query($query);
        $tblc->set_fields($arr_fields);
        $tblc->show_table();
    }

if($tbl == $tbl_pri) {
    $arr_fields = array(
        'pre.id',
        'id_tbl_category',
        'description',
        'material',
        'thick',
        'order_code',
        'company',
        'purchase_price',
        'sales_price',
        'unit',
        );
    $qry = new Query();
    $qry->set_fields($arr_fields);
    $qry->set_order_field('pre.id');
    $qry->set_order_direction('DESC');
    $qry->set_table_or_relation($rel_price_category_unit_address);
    $query = $qry->get_query();
    
    // Show table
    $tblc = new Tbl( $use['db_e']);
    $tblc->set_limit(5);
    $tblc->set_fields($arr_fields);
    $tblc->set_query($query);
    $tblc->show_table();
}
	
}
HTML::printFoot();
?>