<?php
/*
schreinerwissen. auftragsverwaltung 
Copyright (C) 2011  Carsten Hilbert
c-hilbert@web.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Shows page with user settings like address, bank details, logo etc.
 */

require_once 'common.php';

HTML::printHead($css);
HTML::printBody();
HTML::printHeadline($headline);

unset($_SESSION['todo']);

require_once 'include/bar_common.inc.php';


// Update record
$db->update_row($tbl);

require_once 'include/bar_setting.inc.php';

/**
 *  Particular content
 */
$z = 30;
$particulars_cont = '<br/>'
                  . $html->input(1, 'text', 'street', $adm['street'],$z, $la_street)
                  . '<br/>'
                  . $html->input(1, 'text', 'postcode', $adm['postcode'], 8, $la_postcode)
                  . '<br/>'
                  . $html->input(1, 'text', 'city', $adm['city'],$z, $la_city)
                  . '<br/>';

$drop = new Drop_Down();
$arr_fields = array('country');
$drop->set_values_db($tbl_cou, 'id_tbl_country', $arr_fields, $adm['id_tbl_country']);
$drop->set_condition('hide != 1');

$particulars_cont .= $drop->make_drop_down($la_country);

$drop->select_db($use['db_e']);

$particulars_cont .= '<br/>'
                . $html->input(1, 'text', 'phone', $adm['phone'],$z, $la_phone)
                . '<br/>'
                . $html->input(1, 'text', 'fax', $adm['fax'],$z, $la_fax)
                . '<br/>'
                . $html->input(1, 'text', 'mobil', $adm['mobil'],$z, $la_mobil)
                . '<br/>'
                . $html->input(1, 'text', 'homepage', $adm['homepage'],$z, $la_homepage)
                . '<br/>'
                . $html->input(1, 'text', 'email', $adm['email'],$z, $la_email)
                . '<br/>'
                . $html->input(1, 'text', 'tax_id', $adm['tax_id'], 20, $la_tax_id)
                . '<br/>'
                . $html->input(1, 'text', 'tax_number', $adm['tax_number'],20, $la_tax_number)
                . '<br/>';

/**
 *  Layout page
 */
$layout_cont = $html->html_checkbox(1, 'company_name_on', $adm['company_name_on'])
            . $la_show_company
            . '<br/>'
            . $html->input(1, 'text', 'font_size', $adm['font_size'], $z,
                $la_font_size)
            . '<br/>'
            . $html->input(1, 'text', 'company_xy', $adm['company_xy'], $z,
                'Feld Firmenname x,y')
            . '<br/>'
            . $html->input(1, 'text', 'logo_xy', $adm['logo_xy'], $z,
                    'Logo x,y')
            . '<br/>'
            . $html->input(1, 'text', 'company_data_xy', $adm['company_data_xy'], $z,
                'Feld Firmendaten x,y');

/**
 * Logo
 */
if (LOCAL_SYSTEM == false) {
$z = 5;
$logo_cont = '<div style="float:left; padding-right: 30px;">'
            . '<br>'
            . $html->html_checkbox(1, 'logo_on', $adm['logo_on'])
            . $la_logo_show . '<br>'
            . $html->input(1, 'text', 'logo_width', $adm['logo_width'], 5, $la_logo_width)
            . '</div>'
            // timestamp for reload the page
            . '<div style="padding-top: 5;"> <img src="'.LOGO_HTTP.$adm['logo_url'].'?'.time()
            . '" width="80"></div>';
}

/**
 * Date format
 */
$arr = 'tbl=adm&change_data=1&id=1&time_format_doc=d.m.Y';
$title = "d.m.Y -> 03.08.2011 -> Tag.Monat.Jahr";
$date_cont = $html->input(1, 'text', 'time_format_doc', $adm['time_format_doc'], 8)
            . ' '
            . $link->make_link('user_setting.php', $la_restore_default, $arr, $title)
            // Explanation date system
            . $date_description;


/**
 *  Bank details
 */
$z = 25;
$bank_cont = $html->input(1, 'text', 'bank', $adm['bank'], $z, $la_bank)
            . '<br/>'
            . $html->input(1, 'text', 'bank_account_holder', 
                    $adm['bank_account_holder'], $z, $la_bank_account_owner)
            . '<br/>'
            . $html->input(1, 'text', 'bank_account_number', 
                    $adm['bank_account_number'], $z, $la_bank_account_nr)
            . '<br/>'
            . $html->input(1, 'text', 'bank_code', $adm['bank_code'], $z,
                $la_bank_code)
            . '<br/>'
            . $html->input(1, 'text', 'iban', $adm['iban'], $z, 'IBAN')
            . '<br/>'
            . $html->input(1, 'text', 'bic', $adm['bic'], $z, 'BIC');

/**
 * Tax
 */
$z = 5;
$tax_cont = $html->input(1, 'text', 'tax_rate_a', $adm['tax_rate_a'], $z,
                $la_tax_rate)
            . '<br/>'
            . $html->input(1, 'text', 'tax_rate_b', $adm['tax_rate_b'], $z,
                    $la_tax_rate_b)
            . '<br/>'
            . $html->html_checkbox(1, 'invoice_gross', $adm['invoice_gross'])
            . $la_invoice_gross
            . '<br/>'
            . $html->html_checkbox(1, 'tax_on', $adm['tax_on'])
            . $la_tax_calculate
            . '<br/>'
            . $html->html_checkbox(1, 'small_business', $adm['small_business'])
            . $la_small_business;

/**
 * Faktura
 */
$ohne_abzug = urlencode('ohne Abzug.');
$arr = 'tbl=adm&change_data=1&id=1&time_payment_add=' . $ohne_abzug;
$faktura_cont = $html->html_checkbox(1, 'own_doc_number', $adm['own_doc_number'])
            . $la_own_document_nr.' ('.$la_no.' = auto)'
            . '<br/>'
            . $html->input(1, 'text', 'time_payment', $adm['time_payment'],$z,
                    $la_days.' '.$la_date_of_payment)
            . '<br/>'
            . $html->input(1, 'text', 'time_payment_add', $adm['time_payment_add'], 30,
                    $la_date_of_payment_add)
            . ' '
            . $link->make_link('user_setting.php', $la_restore_default, $arr)
            . '<br/>'
            . $html->input(1, 'text', 'currency', $adm['currency'],$z+2,
                    $la_currency);

/**
 * Programm settings
 */
$prog_cont = $html->input(1, 'text', 'interval_row', $adm['interval_row'], $z, $la_intervall)
            . '<br/>'
            . $html->html_checkbox(1, 'weight_article_on', $adm['weight_article_on'])
            . $la_weight_show 
            . ' <img src="image/info.png" title="Interessant fr den Internetshop'
            . 'zur Berechung der Versandkosten">'
            . '<br/>'
            . $html->html_checkbox(1, 'tax_article_on', $adm['tax_article_on'])
            . $la_tax_products_on
            . '<br/>'
            . $html->html_checkbox(1, 'shipping_cost_always', $adm['shipping_cost_always'])
            . $la_shipping_cost_always
            . '<br/>'
            . $html->html_checkbox(1, 'delivered_on', $adm['delivered_on'])
            . $la_delivered_on;

/**
 * Shop
 */
$z = 15;
$shop_cont = $html->input(1, 'text', 'free_shipping_border', $adm['free_shipping_border'], $z,
        $la_free_shipping_border);


/**
 * Calculations
 */
$drop = new Drop_Down($use['db_e']);
$arr_fields = array('money_hour', 'short');
$drop->set_values_db($tbl_hou, 'id_tbl_hourly_rate', $arr_fields, $adm['id_tbl_hourly_rate']);
$drop->set_condition('hide != 1');
$calc_cont = $html->input(1, 'text', 'risk_profit', $adm['risk_profit'], $z, 
                $la_col_wug.' (%)')
            . '<br>'
            . $html->input(1, 'text', 'overheads_material', $adm['overheads_material'],$z,
                $la_overheads_mat.' (%)')
            . '<br>'
            // dropdown with hourly rate
            . $drop->make_drop_down(0)
            . $la_hourly_rate_default;


?>
<div id="tab">
<form method="post" action="<?php print PROJECT_HTTP_ROOT . 'tbl_edit.php';  ?>"
      style="display:inline">
<table>
<tr>
    <th colspan="2" align="left">
        <?php 
        print $adm['company_name'] . " / " . $worker['surname'];
        ?>
    </th>
</tr>
<tr>
    <?php
    $t1 = $html->html_x(1,$la_particulars, 'h2');
    $html->tdh(1, $t1);
    ?>
    <td>
    <textarea name="company_name" cols="35" rows="2"><?php
       print $adm['company_name'];
?></textarea>
        <?php print $particulars_cont; ?>
    </td>
</tr>
    <?php
$html->tr1();
    $layout = $html->html_x(1, $la_layout_page, 'h2', 'display:inline;');
    $html->tdh(1, $layout);
    $html->tdh(1, $layout_cont);
$html->tr2();

// Logo
if ($use['mod_logo'] == 1 and LOCAL_SYSTEM == false) {
    $html->tr1();
        $t1 = $html->html_x(1, $la_logo, 'h2');
        $html->tdh(1, $t1);
        $html->tdh(1, $logo_cont);
    $html->tr2();
}  

$html->tr2();
$html->tr1();
    $t1 = $html->html_x(1, $la_bank_details, 'h2');
    $html->tdh(1, $t1);
    $html->tdh(1, $bank_cont);
$html->tr2();
$html->tr1();
    $z=5;
    $t1 = $html->html_x(1, $la_date_format.' '. $la_in_docs, 'h2');
    $html->tdh(1, $t1);
    $html->tdh(1, $date_cont);
$html->tr2();
$html->tr1();
    $t1 = $html->html_x(1, $la_tax, 'h2');
    $html->tdh(1, $t1);
    $html->tdh(1, $tax_cont);
$html->tr2();
if (LOCAL_SYSTEM == false) {
$html->tr1();
    $t1 = $html->html_x(1, $la_faktura, 'h2');
    $html->tdh(1, $t1);
    $html->tdh(1, $faktura_cont);
$html->tr2();
}
$html->tr1();
    $t1 = $html->html_x(1, $la_programm_settings, 'h2');
    $html->tdh(1, $t1);
    $html->tdh(1, $prog_cont);
$html->tr2();
$html->tr1();
    $shop = $html->html_x(1, 'Shop', 'h2');
    $html->tdh(1, $shop);
    $html->tdh(1, $shop_cont);
$html->tr2();

// Calc
if ($use['mod_calc'] == 1) {
    $html->tr1();
        $t1 = $html->html_x(1, $la_calculations, 'h2');
        $html->tdh(1, $t1);
        $html->tdh(1, $calc_cont);
    $html->tr2();
}  
?>
</table>

<?php
// Hidden inputs
if (!isset($file)) { $file = '';}
$arr = array(
    'tbl' => 'adm',
    'id' => $adm['id'],
    'file' => $file,
);      
$html = new Html_Element();
print $html->make_hidden_input_from_array($arr);
?>      
<div style="position: fixed; top: 100px; right: 10%; ">
        <input style="height: 5em;" type="submit" name="change_data" 
        value="<?php print $la_save_settings; ?>">
</div>
</form>
<br/>
<p>
<?php

// Link free edit
$link_free_edit = new Link_Free_Edit();
print $link_free_edit->get_link();
?>
</p>
</div>
<?php
HTML::printFoot();
?>
